<template>
  <SwPluginSlot name="gs-connection-indicator">
    <div v-if="!isSelfService"
         class="sw-gs-navigation-connection-indicator"
         :class="connected ? 'is-connected' : 'is-disconnected'"
         :title="connected ? $t('Connected') : $t('Not connected. Trying to reconnect...')">
        <span v-if="showConnectError" class="sw-gs-navigation-connection-msg">
          {{ $t('Reconnecting...') }}
        </span>
      <div class="indicator-container">
        <div class="indicator-ring"></div>
        <div class="indicator"></div>
      </div>
    </div>
  </SwPluginSlot>
</template>

<script lang="ts">
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";
  import { useAppointment } from "../logic/composables/useAppointment";
  import { useMercure } from "../logic/composables/useMercure";

  export default {
    name: 'SwGsConnectionIndicator',
    components: {
      SwPluginSlot
    },
    setup() {
      const { isSelfService } = useAppointment();
      const { connected, showConnectError } = useMercure();

      return {
        isSelfService,
        connected,
        showConnectError
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-navigation-connection-indicator {
    align-self: center;
    margin-right: var(--spacer-xs);
    display: flex;
    align-items: center;

    &.is-connected {
      .indicator {
        background-color: var(--c-success);
      }

      .indicator-ring {
        border-color: var(--c-success);
      }
    }

    .sw-gs-navigation-connection-msg {
      margin-left: var(--spacer-xs);
    }
  }

  .indicator-container {
    position: relative;
    width: 40px;
    height: 40px;
  }

  .indicator {
    width: 14px;
    height: 14px;
    background-color: var(--c-danger);
    border-radius: 50%;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .indicator-ring {
    border: 3px solid var(--c-danger);
    border-radius: 30px;
    height: 24px;
    width: 24px;
    position: absolute;
    left: 5px;
    top: 5px;
    animation: pulsate 1s ease-out;
    animation-duration: 8s;
    animation-iteration-count: infinite;
    opacity: 0;
  }

  @-webkit-keyframes pulsate {
    20%, 100% {
      opacity: 0;
      transform: scale(1.2, 1.2);
    }
    0% {
      opacity: 0;
      transform: scale(0.1, 0.1);
    }
    10% {
      opacity: 1;
    }
  }
</style>
